/*
 ADOBE CONFIDENTIAL

 Copyright 2015 Adobe Systems Incorporated
 All Rights Reserved.

 NOTICE:  All information contained herein is, and remains
 the property of Adobe Systems Incorporated and its suppliers,
 if any.  The intellectual and technical concepts contained
 herein are proprietary to Adobe Systems Incorporated and its
 suppliers and may be covered by U.S. and Foreign Patents,
 patents in process, and are protected by trade secret or copyright law.
 Dissemination of this information or reproduction of this material
 is strictly forbidden unless prior written permission is obtained
 from Adobe Systems Incorporated.
 */
(function(document, $) {
    "use strict";
    //download action
    $(document).on("foundation-contentloaded", function(e) {
        var downloadActivator = ".aem-assets-admin-actions-copyrightcheck-activator";
        var downloadAssetModal = "#copyrightcheck";
        var userHome = 'a/admin';
        var lightboxCollectionPathPrefix = "path=/content/dam/collections";
        var lightboxCollectionName = 'lightbox';
        var lightboxCollectionPath = lightboxCollectionPathPrefix + '/' + userHome + '/' + lightboxCollectionName;
        var toDownloadLightbox = false;
        var downloadErrorModal;
        var downloadModalVisibleTrigger = "assets-download-modal-ready";  /*TO CHECK*/

        // Check if the download lightbox collection button was clicked
        $(document).fipo("tap" + ".download-lightbox", "click." + ".download-lightbox", ".download-lightbox", function(e) {
            toDownloadLightbox = true;
            if ($(".mediacart").attr("user-home") !== 'undefined') {
                userHome = $(".mediacart").attr("user-home");
                lightboxCollectionPath = lightboxCollectionPathPrefix + '/' + userHome + '/' + lightboxCollectionName;
            }
        });


        $(document).off("click", downloadActivator).one("click", downloadActivator, function(e) {         
            var activator = $(this);
            var paths = "";
            var pathsObject = {};
            var collection = false;
            var collectionNonLicensedAssets = {};
            //selections
            var items = $(".foundation-selections-item");
            var ui = $(window).adaptTo("foundation-ui");
            if (ui != undefined) {
                ui.wait();
            }
            if (items.length) {
                if (items.data("foundation-collection-item-id").startsWith("/content/dam/collections/")) {                   
                    window.localStorage.setItem('collection', true);
                    collection = true;
                }
                items.each(function(i) {
                    var item = $(this);
                    var itemPath = item.data("foundation-collection-item-id");
                    paths += "path=" + encodeURIComponent(itemPath).replace(/%2F/g, "/") + "&";
                    pathsObject[encodeURIComponent(itemPath).replace(/%2F/g, "/")] = true;
                });


                //remove the last '&'
                paths = paths.substr(0, paths.length - 1);
            } else {
                //quick actions
                var path = activator.data("itempath");
                if (path == undefined) {
                    var pathname = location.pathname;
                    //assetdetails & annotate page
                    if (pathname.indexOf("/assetdetails.html") > -1) {
                        path = decodeURIComponent(pathname.substring(pathname.indexOf("/assetdetails.html") + 18));
                    } else if (pathname.indexOf("/annotate.html") > -1) {
                        path = decodeURIComponent(pathname.substring(pathname.indexOf("/annotate.html") + 14));
                    }
                }
                paths = "path=" + encodeURIComponent(path).replace(/%2F/g, "/");
                pathsObject[encodeURIComponent(path).replace(/%2F/g, "/")] = true;
            }
            // If lightbox collection is to be downloaded then change the paths accordingly
            if (toDownloadLightbox == true) {
                paths = lightboxCollectionPath;
                toDownloadLightbox = false;
            }

            //keep path in window, so that it can be accessible while starting download
            window.localStorage.damAssetDownloads = paths;
            var downloadUrl = Granite.HTTP.externalize(activator.data("href") + "?" + paths + "&ck=" + Date.now() + "&_charset_=utf-8");
            var licenseCheckURL = Granite.HTTP.externalize(activator.data("haslicense-href") + "?" + paths + "&ck=" + Date.now() + "&_charset_=utf-8");
            var licenseSelectionURL = "";
            var contentAPI = activator.closest(".foundation-content").adaptTo("foundation-content");
            var pageTitle = activator.data("pageheading");
            var license = false;


            if (license == true) {
                window.location.href = licenseSelectionURL;
            } else {
                Granite.$.ajax({
                    url: downloadUrl,
                    async: true,
                    success: function(html) {

							if (ui != undefined) {
                            ui.clearWait();
                        }


                        //remove the existing download modal (could be from the previous processing)
                        var oldDialogs = $("coral-dialog[id='copyrightcheck']");
                        var content = html;

                        if (oldDialogs.length==0){
                            $("body").append(html);

                        }
                        else
                        {
							var html2 = "<html><body>"+html+"</body></html>"

                            $("#copyrightcheckForm .filename").replaceWith($(html2).find("#copyrightcheckForm .filename").parent().html());
                            $("#copyrightcheckForm .uuids").replaceWith($(html2).find("#copyrightcheckForm .uuids").parent().html());
                        }

                        // dialog.show() does not work on first startup on firefox so enclosing it in Coral.commons.ready().
                        var dialog = document.querySelector(downloadAssetModal);
	                    Coral.commons.ready(dialog, function() {
                            dialog.show();
                        });



						//	downloadErrorModal.show();

                        // This event is basically an event that will notify that something is injected to the DOM. 
                        // It is used by component handler to check if it has to upgrade the markup (userlist ...) or not.
                        $(downloadAssetModal).trigger("foundation-contentloaded");



                        //window.dispatchEvent(new Event('resize'));

                    },
                    error: function(item) {
                        if (ui != undefined) {
                            ui.clearWait();
                        }

                        if (!downloadErrorModal) {
                            var $reponseHtml = $(Granite.UI.Foundation.Utils.processHtml(item.responseText));
                            var errorMessage = Granite.I18n.get("Failed to download.");
                            var content = errorMessage + "<br>" + $reponseHtml.filter("h1").text();

                            downloadErrorModal = new Coral.Dialog().set({
                                id: "downloadError",
                        	    variant: "error",
                        	    closable: "on",
                        	    header: {
                                    innerHTML: Granite.I18n.get("Error")
                                },
                                content: {
                                    innerHTML: content
                                },
                                footer: {
                                    innerHTML: '<button is="coral-button" class="closeExport" variant="default" coral-close>' + Granite.I18n.get("OK") + '</button>'
                                }
                            });
                        }
                        downloadErrorModal.show();
                    }
                });
            }
        });
    });

})(document, Granite.$);